import pygame
import random  #biblioteka potrebna za generisanje slucajnih brojeva

from pygame.locals import K_UP,K_DOWN, K_LEFT, K_RIGHT, K_ESCAPE, KEYDOWN, QUIT

pygame.init()

SCREEN_WIDTH = 800
SCREEN_HEIGHT = 600

class Player(pygame.sprite.Sprite):
    def __init__(self):
        super().__init__()
        self.image = pygame.Surface((75,25))
        self.image.fill((255,255,255))
        self.rect = self.image.get_rect()

    #metod koji ce se pozivati radi pomeranja
    #igraca po ekranu zavisno od pritisnutih tastera
    def update(self, pressed_keys):
        if pressed_keys[K_UP]:
            self.rect.move_ip(0,-2)  #pomeranje sprajta po x i y koordinatama
        if pressed_keys[K_DOWN]:
            self.rect.move_ip(0,2)
        if pressed_keys[K_LEFT]:
            self.rect.move_ip(-2,0)
        if pressed_keys[K_RIGHT]:
            self.rect.move_ip(2,0)

        #provera da li igrac izlazi van prozora
        if self.rect.left <0:
            self.rect.left = 0
        if self.rect.right>SCREEN_WIDTH:
            self.rect.right=SCREEN_WIDTH
        if self.rect.top <0:
            self.rect.top = 0
        if self.rect.bottom > SCREEN_HEIGHT:
            self.rect.bottom = SCREEN_HEIGHT

#klasa za opis neprijatelja
class Enemy(pygame.sprite.Sprite):

    def __init__(self):
        super().__init__()
        self.image = pygame.Surface((20,10))  #pravljenje pridruzene slike
        self.image.fill((255,255,255))  #definisanje boje neprijatelja
        self.rect = self.image.get_rect(  # random rasporedjivanje neprijatelja
            center =(random.randint(SCREEN_WIDTH + 20, SCREEN_WIDTH + 100),
                random.randint(0, SCREEN_HEIGHT)) )
        self.speed = random.randint(5,20)  # brzina kojom se neprijatelj krece ka igracu

    #metod koji ce se pozivati radi pomeranja
    #neprijatelja po prozoru
    def update(self):
        self.rect.move_ip(-self.speed, 0) #pomeranje neprijatelja
        #ako neprijatelj vise nije vidljiv (desna ivica je na poziciji <0)
        #brise se
        if self.rect.right<0:
            self.kill()

screen = pygame.display.set_mode([SCREEN_WIDTH, SCREEN_HEIGHT])

#definisanje dogadjaja koji oznacava dodavanje novog neprijatelja
ADDENAMY  = pygame.USEREVENT + 1
pygame.time.set_timer(ADDENAMY,250)  #postavljanje tajmera za aktiviranje korisnicki
                                     #definisanog dogadjaja ADDENAMY

player = Player()

#pravljenje grupe koja ce sadrzati sve neprijatelje
enemies = pygame.sprite.Group()
#pravljenje grupe koja ce sadrzati sve sprajtove u igri
all_sprites = pygame.sprite.Group()

#dodavanje igraca u grupu all_sprites
all_sprites.add(player)

running = True

while running:

    for event in pygame.event.get():

        if event.type == KEYDOWN:
            if event.key == K_ESCAPE:
                running = False


        elif event.type == QUIT:
            running = False

        #provera da li se desio korisnicki definisan dogadjaj ADDENAMY
        elif event.type == ADDENAMY:
            new_enemy = Enemy() #pravljenje novog neprijatelja
            # dodavanje neprijatelja u grupe sprajtova
            enemies.add(new_enemy)
            all_sprites.add(new_enemy)

    #svi pritisnuti tasteri
    pressed_keys = pygame.key.get_pressed()

    #azuriranje stanja igraca prema pritisnutim tasterima
    player.update(pressed_keys)
    enemies.update()

    #postavljanje boje prozora
    screen.fill((0, 0,0))

    #iscrtavanje svakog sprajta
    all_sprites.draw(screen)

    #provera da li doslo do kolizije (preklapanja pravugaonika) izmedju
    #igraca i nekog neprijatelja
    if pygame.sprite.spritecollideany(player, enemies):
        player.kill() # brisanje igraca iz svih grupa
        running=False # postavljnje promenjljive running na False
                      # cime se oznacava kraj igre

    #azurira sadrzaj za prikazivanje
    pygame.display.update()

pygame.quit()